/* Generated by Together */

package org.xtm4xmldb.core;

import org.tinyTIM.TopicMapSystemFactoryImpl;
import org.tmapi.core.TopicMapSystemFactory;
import java.util.Properties;
import org.tinyTIM.FeatureSupport;
import org.tmapi.core.FeatureNotRecognizedException;
import org.tmapi.core.FeatureNotSupportedException;

public abstract class abstractTopicMapSystemFactory extends TopicMapSystemFactory {
    public String getProperty(String str) {
        return this.m_props.getProperty(str);
    }

    public void setProperty(String str, String obj) {
        this.m_props.put(str,obj);
    }

    public boolean getFeature(String feature)
    throws FeatureNotRecognizedException { 
        FeatureSupport fs = getFeatureSupport(feature);
        if (!fs.m_fixedValue) {
            if (fs.m_propertyName != null) {
                String propVal = m_props.getProperty(fs.m_propertyName);
                if (propVal != null) {
                    if (propVal.equals(fs.m_propertyTrueValue)) {
                        return true;
                    } else if (propVal.equals(fs.m_propertyFalseValue)) {
                        return false;
                    } else {
                        return Boolean.valueOf(propVal).booleanValue();
                    }
                }
            } else {
                if (m_props.getProperty(fs.m_featureName) != null) {
                    return Boolean.valueOf(m_props.getProperty(fs.m_featureName)).booleanValue();
                }
            }
        }
        return fs.m_defaultValue;
    }

    public boolean hasFeature(String featureName) {
        try {
            getFeatureSupport(featureName);
            return true;
        } catch (FeatureNotRecognizedException  ex) {
            return false;
        }
    }

    public void setFeature(String feature, boolean value)
    throws FeatureNotSupportedException, FeatureNotRecognizedException {
        FeatureSupport fs = getFeatureSupport(feature);
        if (fs.m_fixedValue) {
            if (fs.m_defaultValue != value) {
                throw new FeatureNotSupportedException("The feature " + feature + " has a fixed value of " + fs.m_defaultValue + " which cannot be altered.");
            }
        } else {
            if (fs.m_propertyName != null) {
                if (value) {
                    m_props.setProperty(fs.m_propertyName, fs.m_propertyTrueValue == null ? "true" : fs.m_propertyTrueValue);
                } else {
                    m_props.setProperty(fs.m_propertyName, fs.m_propertyFalseValue == null ? "false" : fs.m_propertyFalseValue);
                }
            } else {
                m_props.setProperty(feature, String.valueOf(value));
            }
        }
    }

    private FeatureSupport getFeatureSupport(String feature) throws FeatureNotRecognizedException {
        for (int i = 0; i < m_features.length; i++) {
            if (m_features[i].m_featureName.equals(feature)) {
                return m_features[i];
            }
        }
        throw new FeatureNotRecognizedException("The feature name '" + feature + "' is not recognized.");
    }

    public void setProperties(Properties properties){
        this.m_props=properties;
    }

    protected Properties m_props = new Properties();
    protected FeatureSupport[] m_features = new FeatureSupport[] {
        new FeatureSupport("http://tmapi.org/features/notation/URI", true, true),
        new FeatureSupport("http://tmapi.org/features/model/xtm1.0", false, true),
        new FeatureSupport("http://tmapi.org/features/model/xtm1.1", false, false),
        new FeatureSupport("http://tmapi.org/features/automerge", false, false),
        new FeatureSupport("http://tmapi.org/features/merge/byTopicName", false, true),
        new FeatureSupport("http://tmapi.org/features/readOnly", true, false),    
        
    };
}
