/* Generated by Together */

package org.xtm4xmldb.core;

import java.util.Collection;

import org.tinyTIM.TopicImpl;
import org.tmapi.core.*;
import org.tmapiutils.impexp.xtm.XTMParser;
import org.xtm4xmldb.utils.*;

import org.xmldb.api.base.Resource;
import org.xmldb.api.base.XMLDBException;

import java.util.Set;

public class xtm4xmldb_Topic extends TopicImpl implements Topic, XTMsnippet {
    private boolean usable;
    private boolean isProxy=false;
    private boolean isParsing=false;
    private xtm4xmldb_TopicMap xtmap;
    private Resource res;
    /*
     * parses an <topic> tag
     */
    public xtm4xmldb_Topic(xtm4xmldb_TopicMap tmap,Resource res)throws XMLDBException{
        super(tmap,res.getId());
        this.res = res;
        this.usable=true;
        this.xtmap=tmap; 
        parse();
    }
    /*
     * creates a proxy
     */
    public xtm4xmldb_Topic(xtm4xmldb_TopicMap tmap, String xmlid, boolean usable){
        super(tmap,xmlid);
        this.res=null;
        this.usable=usable;
        this.xtmap=tmap; 
        this.isProxy=true;
        System.out.println("created proxy "+usable);
    }
    /*
     * creates a new one
     */
    public xtm4xmldb_Topic(xtm4xmldb_TopicMap tmap){
        super(tmap);
        this.usable=true;
        this.xtmap=tmap;
        try{
            this.res=this.xtmap.getCollection().createResource( super.getObjectId(), "XMLResource");
        }catch(XMLDBException e){
            e.printStackTrace();
        }
        sync();
    }
    /*
     * creates a new one with xmlid
     */
    public xtm4xmldb_Topic(xtm4xmldb_TopicMap tmap,String xmlid){
        super(tmap,xmlid);
        this.usable=true;
        this.xtmap=tmap;
        try{
            this.res=this.xtmap.getCollection().createResource( super.getObjectId(), "XMLResource");
        }catch(XMLDBException e){
            e.printStackTrace();
        }
        sync();
    }    
    public void ISusable(){
        if(this.usable==false){
            this.usable=true;
            //get real proxy
            try{
                this.res=this.xtmap.getTopicCollection().getResource(getObjectId());
                parse();
            }catch(XMLDBException e){
                e.printStackTrace();
            }
        }
    }
    
    private void parse(){
        this.isParsing=true;
        try{
         //   System.out.println("parseTopic: "+(String)this.res.getContent());            
            this.xtmap.parser.parseTopic(this, (String)this.res.getContent());
        }catch(Exception e){
            e.printStackTrace();
        }
        this.isParsing=false;        
    }
    
    public TopicName createTopicName(String TopicNameString, Collection scope){
        ISusable();
        TopicName tn = super.createTopicName(TopicNameString, scope);
        System.out.println("created TopicName"+TopicNameString+" "+tn.getObjectId());
        this.sync();
        return(tn);
    }
    
    public TopicName createTopicName(String TopicNameString, Topic type, Collection scope){
        ISusable();
        TopicName tn = super.createTopicName(TopicNameString, type, scope);
        this.sync();
        return(tn);
    }
    
    public Occurrence createOccurrence(String resourceData, Topic type, Collection scope){
        ISusable();
        Occurrence oc = super.createOccurrence(resourceData, type, scope);
        this.sync();
        return(oc);
    }
    
    public Occurrence createOccurrence(Locator resourceRef, Topic type, Collection scope){
        ISusable();
        Occurrence oc = super.createOccurrence(resourceRef, type, scope);
        this.sync();
        return(oc);
    }
    
    public void addSubjectLocator(Locator subjectAddress){
        ISusable();
        if(this.tm.addSubjectLocator(this, subjectAddress,((!merging)&&(!isParsing)))){
            super.subjectAddresses.add(subjectAddress);   
            this.sync();
        }
    }
    
    public void removeSubjectLocator(Locator subjectLocator){
        ISusable();
        super.removeSubjectLocator(subjectLocator);
        this.sync();
    }
    
    public void addSubjectIdentifier(Locator subjectIndicator){
        ISusable();
        if(this.tm.addSubjectIdentifier(this, subjectIndicator,((!merging)&&(!isParsing)))){
            super.subjectIndicators.add(subjectIndicator);   
            this.sync();
        }
    }
    
    public void removeSubjectIdentifier(Locator subjectIndicator){
        ISusable();
        super.removeSubjectIdentifier(subjectIndicator);
        this.sync();
    }
    
    public void addType(Topic type){
        ISusable();
        super.addType(type);
        this.sync();
    }
    
    public void removeType(Topic type){
        ISusable();
        super.removeType(type);
        this.sync();
    }
    
    public void sync(){
        if(this.isParsing==false){
            try{
                String xml = this.xtmap.serializer.serialize(this);
                res.setContent(xml);
                System.out.println("Sync Topic "+getObjectId());
                //System.out.println(xml);
                this.xtmap.getTopicCollection().storeResource(res);
            }catch(Exception e){
                e.printStackTrace();
            }
        }
    }
    
    public Set getTopicNames(){
        ISusable();
        return(super.getTopicNames());
    }
    public Set getRolesPlayed(){
        return(new xmldb_XPathRolePlayedSet((xtm4xmldb_TopicMap)this.tm,this));
    }
    public void remove()throws TopicInUseException{ 
        System.out.println("----remove myself"+getObjectId());
        if(this.res!=null){
            try{
                this.xtmap.getTopicCollection().removeResource(this.res);
            }catch(XMLDBException e){
                e.printStackTrace();
            }
        }else if(this.isProxy==true){
            try{
                this.xtmap.getTopicCollection().removeResource(this.xtmap.getTopicCollection().getResource(getObjectId()));
            }catch(XMLDBException e){
                e.printStackTrace();
            } 
        }
        super.remove();
    }
    
    protected void hasChanged(){
        //do nothing
        System.out.println("xtm4xmldb_Topic.hasChanged");
        sync();
    }
    
}
