/*
This is XTM4XMLDB, a TMAPI implementation for native XMLdb's
Copyright (C) 2003  Stefan Lischke
 
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.
 
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.
 
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.
 
Stefan Lischke, hereby disclaims all copyright interest in
the library 'XTM4XMLDB' (a TMAPI implementation).
 
Stefan Lischke (lischke@novacom.net)
 */
package org.xtm4xmldb.core;

import org.tmapi.core.*;
import org.xmldb.api.*;
import org.xmldb.api.base.*;

import org.tinyTIM.FeatureSupport;
import java.util.Properties; 
public class xtm4xmldb_TopicMapSystemFactory extends abstractTopicMapSystemFactory{
    private FeatureSupport[] m_features = new FeatureSupport[] {
        new FeatureSupport("http://tmapi.org/features/notation/URI", true, true),
        new FeatureSupport("http://tmapi.org/features/model/xtm1.0", true, true),
        new FeatureSupport("http://tmapi.org/features/model/xtm1.1", true, false),
        new FeatureSupport("http://tmapi.org/features/automerge", false, false),
        new FeatureSupport("http://tmapi.org/features/merge/byTopicName", false, false),
        new FeatureSupport("http://tmapi.org/features/readOnly", true, false),  
    };    
    
    public org.tmapi.core.TopicMapSystem newTopicMapSystem() throws org.tmapi.core.TMAPIException {
        try{
           //create XMLDBD Database
           Class cls = Class.forName(this.m_props.getProperty("org.xmldb.api.base.Database"));
            Database db = (Database) cls.newInstance();
            DatabaseManager.registerDatabase(db);
           TopicMapSystem tsystem = new xtm4xmldb_TopicMapSystem(db, this.m_props,this.m_features);
            return(tsystem);
        }catch(XMLDBException e){
            throw new FactoryConfigurationException("Problems connecting to XMLDB "+this.m_props.getProperty("org.xtm4xmldb.xmldbURI"),e);
        }catch(ClassNotFoundException e){
            throw new FactoryConfigurationException("Cannot find "+this.m_props.getProperty("org.xmldb.api.base.Database"),e);
        }catch(InstantiationException e){
            throw new FactoryConfigurationException("Cannot instantiate "+this.m_props.getProperty("org.xmldb.api.base.Database"),e);
        }catch(IllegalAccessException e){
            throw new FactoryConfigurationException("Cannot access "+this.m_props.getProperty("org.xmldb.api.base.Database"),e);
        }
    }        
}
