package org.xtm4xmldb.index.core;

import org.xtm4xmldb.core.*;
import org.tmapi.core.*;

public class xmldb_TopicsIndex implements org.tmapi.index.core.TopicsIndex {
    private xtm4xmldb_TopicMap tm;  
    private org.tmapi.index.IndexFlags iF;
    
    public void configure(TopicMap tm){ 
        this.tm=(xtm4xmldb_TopicMap)tm;
        this.iF=new org.xtm4xmldb.index.AutoUpdatedIndexFlags();
    } 
    
  public void reindex() throws org.tmapi.index.TMAPIIndexException {
    }
    public void close() throws org.tmapi.index.TMAPIIndexException {
    }
    
    public org.tmapi.index.IndexFlags getFlags() throws org.tmapi.index.TMAPIIndexException {
        return(this.iF);
    }   
    public boolean isOpen() throws org.tmapi.index.TMAPIIndexException {
        return(true);
    }    
    
    public java.util.Collection getTopicTypes() {
        return(new org.xtm4xmldb.utils.emptySet());
    }
    
    public java.util.Collection getTopicsByType(org.tmapi.core.Topic type) {
        try{
            java.util.Set   topics  =   new org.xtm4xmldb.utils.xmldb_XPathTopicSet("/topic[instanceOf/topicRef/@xlink:href='#"+type.getObjectId()+"']", this.tm );
            return(topics);        
        }catch(org.xmldb.api.base.XMLDBException e){
            e.printStackTrace();
            return(new org.xtm4xmldb.utils.emptySet());
        }
    }
    
    public java.util.Collection getTopicsByTypes(org.tmapi.core.Topic[] types,boolean matchall) {
        return(new org.xtm4xmldb.utils.emptySet());
    }
    
    
    public void open() throws org.tmapi.index.TMAPIIndexException {        

    }
    
    public org.tmapi.core.Topic getTopicBySubjectLocator(org.tmapi.core.Locator subjAddress) {  
        try{
            java.util.Set   topics  =   new org.xtm4xmldb.utils.xmldb_XPathTopicSet("/topic[subjectIdentity/resourceRef/@xlink:href='"+subjAddress.getReference()+"']", this.tm );
            if(topics.size()==0)
                return null;
            return((org.tmapi.core.Topic)topics.iterator().next());        
        }catch(org.xmldb.api.base.XMLDBException e){
            e.printStackTrace();
            return(null);
        }
    }    
    
    public org.tmapi.core.Topic getTopicBySubjectIdentifier(org.tmapi.core.Locator subjInd) {
        try{
            java.util.Set   topics  =   new org.xtm4xmldb.utils.xmldb_XPathTopicSet("/topic[subjectIdentity/subjectIndicatorRef/@xlink:href='"+subjInd.getReference()+"']", this.tm );
            if(topics.size()==0)
                return null;
            return((org.tmapi.core.Topic)topics.iterator().next());        
        }catch(org.xmldb.api.base.XMLDBException e){
            e.printStackTrace();
            return(null);
        }
    }
  
}
