/*
This is XTM4XMLDB, a TMAPI implementation for native XMLdb's
Copyright (C) 2003  Stefan Lischke

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Stefan Lischke, hereby disclaims all copyright interest in
the library 'XTM4XMLDB' (a TMAPI implementation).

Stefan Lischke (lischke@novacom.net)
*/
package org.xtm4xmldb.utils;

import java.util.Iterator;
import org.xmldb.api.base.*;
import org.xmldb.api.modules.*;

import org.xtm4xmldb.core.*;

public class xmldb_AssociationIterator implements Iterator {
    private xmldb_AssociationSet  set;
    private xtm4xmldb_TopicMap  tmap;
    private int             current;
    public xmldb_AssociationIterator(xmldb_AssociationSet set,xtm4xmldb_TopicMap tmap){        
        this.set        =   set;
        this.tmap       =   tmap;
        this.current    =   0;
    }
    
    public boolean hasNext() {
        return(current<set.size());
    }
    
    
    public Object next() {
        xtm4xmldb_Association  assoc    =   null;
        try{
            //get Assoc
            assoc   =   new xtm4xmldb_Association(this.tmap,this.set.getName(current),false);
            current++;     
        }catch(Exception e){
            e.printStackTrace();
        }
        return(assoc);
    }
    
    public void remove() {
    }
    
}
