/*
This is XTM4XMLDB, a TMAPI implementation for native XMLdb's
Copyright (C) 2003  Stefan Lischke

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Stefan Lischke, hereby disclaims all copyright interest in
the library 'XTM4XMLDB' (a TMAPI implementation).

Stefan Lischke (lischke@novacom.net)
*/
package org.xtm4xmldb.utils;

import java.util.Iterator;

import org.xmldb.api.base.*;

import org.xtm4xmldb.utils.xmldb_BaseLocatorSet;
import org.xtm4xmldb.core.*;

import org.tinyTIM.LocatorImpl;

public class xmldb_BaseLocatorIterator implements Iterator {
    private org.xtm4xmldb.utils.xmldb_BaseLocatorSet s;
    private xtm4xmldb_TopicMapSystem    tsystem;
    private int current;
    public xmldb_BaseLocatorIterator(org.xtm4xmldb.utils.xmldb_BaseLocatorSet s, xtm4xmldb_TopicMapSystem tsystem){
        this.s      =   s;
        this.tsystem=   tsystem;
        this.current=   0;
    }
    
    public boolean hasNext() {
        return(current<s.size());
    }
    
    public Object next() {
        org.tmapi.core.Locator loc  =   new LocatorImpl(s.getBaseLocatorReference(current));
        current++;
        return(loc);
    }
    
    public void remove() {
    }
    
}
