/*
This is XTM4XMLDB, a TMAPI implementation for native XMLdb's
Copyright (C) 2003  Stefan Lischke

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Stefan Lischke, hereby disclaims all copyright interest in
the library 'XTM4XMLDB' (a TMAPI implementation).

Stefan Lischke (lischke@novacom.net)
*/
package org.xtm4xmldb.utils;

import org.xmldb.api.base.*;
import org.xmldb.api.modules.*;
import org.xmldb.api.*;
import java.util.AbstractSet;
import java.util.Iterator;

import org.xtm4xmldb.core.*;

public class xmldb_BaseLocatorSet extends AbstractSet {       
    private String[] names;
    private xtm4xmldb_TopicMapSystem tms;
    public xmldb_BaseLocatorSet(xtm4xmldb_TopicMapSystem tms){
        this.tms    =   tms;   
        //getting all subcollections
        try{
            this.names  =   tms.getStartCol().listChildCollections();
        }catch(XMLDBException e){
            e.printStackTrace();
        }
    }
        
    public String getBaseLocatorReference(int index){
        return(names[index]);
    }    
    
    public int size() {
        return(names.length);
    }

    public Iterator iterator() {
        return(new xmldb_BaseLocatorIterator(this,this.tms));
    }    
    
    public java.util.Set entrySet(){
        return new emptySet();
    }
}
