/*
This is XTM4XMLDB, a TMAPI implementation for native XMLdb's
Copyright (C) 2003  Stefan Lischke

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Stefan Lischke, hereby disclaims all copyright interest in
the library 'XTM4XMLDB' (a TMAPI implementation).

Stefan Lischke (lischke@novacom.net)
*/
package org.xtm4xmldb.utils;

import org.xtm4xmldb.core.*;

import org.xmldb.api.base.*;
import org.xmldb.api.modules.*;
import org.xmldb.api.*;
import java.util.Iterator;

import java.util.AbstractSet;
public class xmldb_XPathAssociationSet extends AbstractSet {
    private xtm4xmldb_TopicMap  tmap;
    private ResourceSet rset;    
    
    public xmldb_XPathAssociationSet(String xpath, xtm4xmldb_TopicMap tmap) throws XMLDBException{        
        this.tmap   =   tmap;
        XPathQueryService   service =   tmap.getAssociationXPathQueryService();
        this.rset   =   service.query(xpath);
       // System.out.println("XPathAssociationSet  : "+xpath+" found "+this.rset.getSize());
    }     
    public Iterator iterator() {
        java.util.Iterator  it  =   null;
        try{
            it  =   new xmldb_XPathAssociationIterator(this.rset.getIterator(),this.tmap);
        }catch(XMLDBException e){
            e.printStackTrace();
        }
        return(it);
    }
    public int size() {
        int s   =   0;
        try{
            s   =   (int)this.rset.getSize();
        }catch(XMLDBException e){
            e.printStackTrace();            
        }
        return(s);
    }    
    
}
