/*
This is XTM4XMLDB, a TMAPI implementation for native XMLdb's
Copyright (C) 2003  Stefan Lischke

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Stefan Lischke, hereby disclaims all copyright interest in
the library 'XTM4XMLDB' (a TMAPI implementation).

Stefan Lischke (lischke@novacom.net)
*/
package org.xtm4xmldb.utils;

import org.xtm4xmldb.core.*;
import org.tmapi.core.TMAPIRuntimeException;
import org.xmldb.api.base.*;
import org.xmldb.api.modules.*;
import org.xmldb.api.*;

import java.util.Iterator;

import java.util.AbstractSet;

public class xmldb_XPathRolePlayedSet extends AbstractSet {
    private xtm4xmldb_TopicMap  tmap;
    private String id;
    private ResourceSet rset;    
    
    public xmldb_XPathRolePlayedSet(xtm4xmldb_TopicMap tmap, xtm4xmldb_Topic t){        
    try{
        this.tmap   =   tmap;
        this.id     =   t.getObjectId();
        String xpath    =   " /association[member/topicRef/@xlink:href='#"+this.id+"']"; 
        this.rset   =   tmap.getAssociationXPathQueryService().query(xpath);
        }catch(XMLDBException e){
            throw new TMAPIRuntimeException(e);
        }
 //       System.out.println("XPathRolePlayedSet : "+xpath + " found "+this.size());
    }     
    public Iterator iterator() {
        java.util.Iterator  it  =   null;
        try{
            it  =   new xmldb_XPathRolePlayedIterator(this.rset.getIterator(), this.tmap, this.id);
        }catch(XMLDBException e){
            throw new TMAPIRuntimeException(e);
        }
        return(it);
    }
    
    public int size() {
        int s   =   0;
        try{
            s   =   (int)this.rset.getSize();
        }catch(XMLDBException e){
            throw new TMAPIRuntimeException(e);
        }
        return(s);
    }      
    
}
