/*
This is XTM4XMLDB, a TMAPI implementation for native XMLdb's
Copyright (C) 2003  Stefan Lischke

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Stefan Lischke, hereby disclaims all copyright interest in
the library 'XTM4XMLDB' (a TMAPI implementation).

Stefan Lischke (lischke@novacom.net)
*/
package org.xtm4xmldb.utils;

import org.xtm4xmldb.core.*;

import org.xmldb.api.base.*;
import org.xmldb.api.modules.*;

import org.tmapi.core.Topic;
import org.tmapi.core.TMAPIRuntimeException;

public class xmldb_XPathTopic{
    
    public static Topic get(String xpath, xtm4xmldb_TopicMap tmap){    
        System.out.println("xmldb_XPathTopic("+xpath+")");
        try{
        XPathQueryService   service =   tmap.getTopicXPathQueryService();
        service.setNamespace("xlink", "http://www.w3.org/1999/xlink");
//        service.setNamespace("xtm", "http://www.topicmaps.org/xtm/1.0/");
        ResourceSet  rs=   service.query(xpath);
        System.out.println("xmldb_XPathTopic("+xpath+") : "+rs.getSize());        
        if(rs.getSize()>0){
            Resource r = rs.getResource(0);
          //  System.out.println("-----"+(String)r.getContent());
            return(new xtm4xmldb_Topic(tmap,r));
        }else
            return null;
        }catch(XMLDBException e){
            throw new TMAPIRuntimeException(e);
        }
    }     
}
