/*
This is XTM4XMLDB, a TMAPI implementation for native XMLdb's
Copyright (C) 2003  Stefan Lischke

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Stefan Lischke, hereby disclaims all copyright interest in
the library 'XTM4XMLDB' (a TMAPI implementation).

Stefan Lischke (lischke@novacom.net)
*/
package org.xtm4xmldb.utils;

import org.xtm4xmldb.core.*;

import org.xmldb.api.base.*;
import org.xmldb.api.modules.*;

import org.tmapi.core.*;

public class xmldb_XPathTopicMapObject{
    
    public static TopicMapObject getBySourceLocator(xtm4xmldb_TopicMap tmap,Locator loc){
        try{
       String xpath = "/topic[*/@sourceLocator='"+loc.getReference()+"']";
        //String xpathquery   =   "document(\""+ tmap.getBaseAddress().getAddress()+"/topics/)"+xpath; 
      //  tmap.getTopic_XPathQueryService().setNamespace("", "http://www.topicmaps.org/xtm/1.0/");
        ResourceSet rset   =   tmap.getTopicXPathQueryService().query(xpath);
        System.out.println("XPathTopicMapObjectSet topic: "+xpath + " found "+rset.getSize()); 
         if(rset.getSize()>0){
            Resource r = rset.getResource(0);
            System.out.println("-----"+(String)r.getContent());
            xtm4xmldb_Topic topic = new xtm4xmldb_Topic(tmap,r);
            return(topic.getObjectBySourceLocator(loc));
           
        }else{
            xpath = "/association[*/@sourceLocator='"+loc.getReference()+"']";
            rset   =   tmap.getAssociationXPathQueryService().query(xpath);
            System.out.println("XPathTopicMapObjectSet assoc: "+xpath + " found "+rset.getSize()); 
            if(rset.getSize()>0){
                Resource r = rset.getResource(0);
                xtm4xmldb_Association assoc   =   new xtm4xmldb_Association(tmap,r);
                //return the TMO with id
                return(assoc.getObjectBySourceLocator(loc));
            }
        }
        return null;
               }catch(XMLDBException e){
           throw new TMAPIRuntimeException(e);
       }
    }    
   public static TopicMapObject getById(xtm4xmldb_TopicMap tmap, String id) {
       try{
        String xpath = "/topic[*/@id='"+id+"']";
        //String xpathquery   =   "document(\""+ tmap.getBaseAddress().getAddress()+"/topics/)"+xpath; 
      //  tmap.getTopic_XPathQueryService().setNamespace("", "http://www.topicmaps.org/xtm/1.0/");
        ResourceSet rset   =   tmap.getTopicXPathQueryService().query(xpath);
        System.out.println("XPathTopicMapObjectSet topic: "+xpath + " found "+rset.getSize()); 
         if(rset.getSize()>0){
            Resource r = rset.getResource(0);
            System.out.println("-----"+(String)r.getContent());
            xtm4xmldb_Topic topic = new xtm4xmldb_Topic(tmap,r);
            return(topic.getObjectById(id));
           
        }else{
            xpath = "/association[*/@id='"+id+"']";
            rset   =   tmap.getAssociationXPathQueryService().query(xpath);
            if(rset.getSize()>0){
                Resource r = rset.getResource(0);
                xtm4xmldb_Association assoc   =   new xtm4xmldb_Association(tmap,r);
                //return the TMO with id
                return(assoc.getObjectById(id));
            }
        }
        return null;
       }catch(XMLDBException e){
           throw new TMAPIRuntimeException(e);
       }
    }         
}
